/*
 *
 * Copyright (c) 2025. Jeffery Hsu - Achievement Report Generator
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <https://www.gnu.org/licenses/>.
 *
 */

import { Course } from '@renderer/models/Course'
import { Assessment } from '@renderer/models/Assessment'
import { Student } from '@renderer/models/Student'

export class ReportDocument {
  private _course: Course
  private _assessment: Assessment
  private _students: Student[]

  constructor(course: Course, assessment: Assessment, students: Student[]) {
    this._course = course
    this._assessment = assessment
    this._students = students
  }

  public static factory() {
    return new ReportDocument(Course.factory(), Assessment.factory(), [])
  }

  get course(): Course {
    return this._course
  }

  set course(value: Course) {
    this._course = value
  }

  get assessment(): Assessment {
    return this._assessment
  }

  set assessment(value: Assessment) {
    this._assessment = value
  }

  get students(): Student[] {
    return this._students
  }

  set students(value: Student[]) {
    this._students = value
  }
}
